/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.42 Revision 1.120
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.42 2009/07/13 19:55:30 hwoarang Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.120 2012/02/28 18:53:45 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
11# @DESCRIPTION: 9# @DESCRIPTION:
12# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
13 11
14inherit base eutils multilib toolchain-funcs flag-o-matic versionator 12inherit base eutils multilib toolchain-funcs flag-o-matic versionator
15 13
14MY_PV=${PV/_/-}
15MY_P=qt-everywhere-opensource-src-${MY_PV}
16
17HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/"
18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
19LICENSE="|| ( LGPL-2.1 GPL-3 )"
20
16IUSE="${IUSE} debug pch" 21IUSE="aqua debug pch"
22
23[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] &&
24[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
25 IUSE+=" +exceptions"
26
27if version_is_at_least 4.7.99999999; then
28 IUSE+=" c++0x qpa"
29fi
30
31DEPEND="dev-util/pkgconfig"
17RDEPEND=" 32RDEPEND="
18 !<x11-libs/qt-assistant-${PV} 33 !<x11-libs/qt-assistant-${PV}
19 !>x11-libs/qt-assistant-${PV}-r9999 34 !>x11-libs/qt-assistant-${PV}-r9999
20 !<x11-libs/qt-core-${PV} 35 !<x11-libs/qt-core-${PV}
21 !>x11-libs/qt-core-${PV}-r9999 36 !>x11-libs/qt-core-${PV}-r9999
22 !<x11-libs/qt-dbus-${PV} 37 !<x11-libs/qt-dbus-${PV}
23 !>x11-libs/qt-dbus-${PV}-r9999 38 !>x11-libs/qt-dbus-${PV}-r9999
39 !<x11-libs/qt-declarative-${PV}
40 !>x11-libs/qt-declarative-${PV}-r9999
24 !<x11-libs/qt-demo-${PV} 41 !<x11-libs/qt-demo-${PV}
25 !>x11-libs/qt-demo-${PV}-r9999 42 !>x11-libs/qt-demo-${PV}-r9999
26 !<x11-libs/qt-gui-${PV} 43 !<x11-libs/qt-gui-${PV}
27 !>x11-libs/qt-gui-${PV}-r9999 44 !>x11-libs/qt-gui-${PV}-r9999
45 !<x11-libs/qt-multimedia-${PV}
46 !>x11-libs/qt-multimedia-${PV}-r9999
28 !<x11-libs/qt-opengl-${PV} 47 !<x11-libs/qt-opengl-${PV}
29 !>x11-libs/qt-opengl-${PV}-r9999 48 !>x11-libs/qt-opengl-${PV}-r9999
49 !<x11-libs/qt-openvg-${PV}
50 !>x11-libs/qt-openvg-${PV}-r9999
30 !<x11-libs/qt-phonon-${PV} 51 !<x11-libs/qt-phonon-${PV}
31 !>x11-libs/qt-phonon-${PV}-r9999 52 !>x11-libs/qt-phonon-${PV}-r9999
32 !<x11-libs/qt-qt3support-${PV} 53 !<x11-libs/qt-qt3support-${PV}
33 !>x11-libs/qt-qt3support-${PV}-r9999 54 !>x11-libs/qt-qt3support-${PV}-r9999
34 !<x11-libs/qt-script-${PV} 55 !<x11-libs/qt-script-${PV}
42 !<x11-libs/qt-webkit-${PV} 63 !<x11-libs/qt-webkit-${PV}
43 !>x11-libs/qt-webkit-${PV}-r9999 64 !>x11-libs/qt-webkit-${PV}-r9999
44 !<x11-libs/qt-xmlpatterns-${PV} 65 !<x11-libs/qt-xmlpatterns-${PV}
45 !>x11-libs/qt-xmlpatterns-${PV}-r9999 66 !>x11-libs/qt-xmlpatterns-${PV}-r9999
46" 67"
47case "${PV}" in 68
48 4.?.?_rc*)
49 SRCTYPE="${SRCTYPE:-opensource-src}"
50 MY_PV="${PV/_rc/-rc}"
51 ;;
52 *)
53 SRCTYPE="${SRCTYPE:-opensource-src}"
54 MY_PV="${PV}"
55 ;;
56esac
57MY_P=qt-x11-${SRCTYPE}-${MY_PV}
58S=${WORKDIR}/${MY_P} 69S=${WORKDIR}/${MY_P}
59 70
60HOMEPAGE="http://www.qtsoftware.com/"
61SRC_URI="http://get.qtsoftware.com/qt/source/${MY_P}.tar.bz2"
62
63case "${PV}" in
64 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
65 *) ;;
66esac
67
68if version_is_at_least 4.5 ${PV} ; then
69 LICENSE="|| ( LGPL-2.1 GPL-3 )"
70fi
71
72# @FUNCTION: qt4-build_pkg_setup 71# @FUNCTION: qt4-build_pkg_setup
73# @DESCRIPTION: 72# @DESCRIPTION:
74# Sets up installation directories, PLATFORM, PATH, and LD_LIBRARY_PATH 73# Sets up PATH and LD_LIBRARY_PATH.
75qt4-build_pkg_setup() { 74qt4-build_pkg_setup() {
76 # EAPI=2 ebuilds set use-deps, others need this: 75 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
77 if [[ $EAPI != 2 ]]; then 76
78 # Make sure debug setting corresponds with qt-core (bug 258512) 77 # Protect users by not allowing downgrades between releases
79 if [[ $PN != "qt-core" ]]; then 78 # Downgrading revisions within the same release should be allowed
80 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 79 if has_version '>'${CATEGORY}/${P}-r9999; then
81 ~x11-libs/qt-core-${PV} debug" 80 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
81 eerror "Sanity check to keep you from breaking your system:"
82 eerror " Downgrading Qt is completely unsupported and will break your system!"
83 die "aborting to save your system"
84 else
85 ewarn "Downgrading Qt is completely unsupported and will break your system!"
82 fi 86 fi
87 fi
83 88
84 # Check USE requirements 89 if [[ ${PN} == "qt-webkit" ]]; then
85 qt4-build_check_use 90 eshopts_push -s extglob
91 if is-flagq '-g?(gdb)?([1-9])'; then
92 echo
93 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
94 ewarn "You may experience really long compilation times and/or increased memory usage."
95 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
96 ewarn "For more info check out bug #307861"
97 echo
86 fi 98 fi
99 eshopts_pop
100 fi
87 101
88 PATH="${S}/bin:${PATH}" 102 PATH="${S}/bin${PATH:+:}${PATH}"
103 if [[ ${CHOST} != *-darwin* ]]; then
89 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}" 104 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
105 else
106 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
107 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
108 # platform detection. Note: needs to come before any directories to
109 # avoid extract failure.
110 [[ ${CHOST} == *-apple-darwin* ]] && \
111 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
112 ${QT4_EXTRACT_DIRECTORIES}"
113 fi
90 114
115 # Make sure ebuilds use the required EAPI
116 if [[ ${EAPI} != [234] ]]; then
117 eerror "The qt4-build eclass requires EAPI 2,3 or 4 but this ebuild is using"
118 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
119 eerror "fixed. Using qt4-build eclass without EAPI 2,3 or 4 will fail."
120 die "qt4-build eclass requires EAPI 2,3 or 4"
121 fi
122
91 if ! version_is_at_least 4.1 $(gcc-version) ; then 123 if ! version_is_at_least 4.1 $(gcc-version); then
92 ewarn "Using a GCC version lower than 4.1 is not supported!" 124 ewarn "Using a GCC version lower than 4.1 is not supported!"
93 echo
94 ebeep 3
95 fi 125 fi
96} 126}
97 127
98# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 128# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
99# @DESCRIPTION: 129# @DESCRIPTION:
100# Arguments for build_target_directories. Takes the directories, in which the 130# Arguments for build_target_directories. Takes the directories in which the
101# code should be compiled. This is a space-separated list 131# code should be compiled. This is a space-separated list.
102 132
103# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 133# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
104# @DESCRIPTION: 134# @DESCRIPTION:
105# Space separated list including the directories that will be extracted from Qt 135# Space-separated list including the directories that will be extracted from
106# tarball 136# Qt tarball.
107 137
108# @FUNCTION: qt4-build_src_unpack 138# @FUNCTION: qt4-build_src_unpack
109# @DESCRIPTION: 139# @DESCRIPTION:
110# Unpacks the sources 140# Unpacks the sources.
111qt4-build_src_unpack() { 141qt4-build_src_unpack() {
112 setqtenv 142 setqtenv
113 local target targets licenses 143
114 if version_is_at_least 4.5 ${PV} ; then 144 local tarball="${MY_P}.tar.gz" target= targets=
115 licenses="LICENSE.GPL3 LICENSE.LGPL" 145 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
116 else
117 licenses="LICENSE.GPL2 LICENSE.GPL3"
118 fi
119 for target in configure ${licenses} projects.pro \
120 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 146 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
121 ${QT4_EXTRACT_DIRECTORIES}; do 147 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
148 do
122 targets="${targets} ${MY_P}/${target}" 149 targets+="${MY_P}/${target} "
123 done 150 done
124 151
125 echo tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets} 152 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
126 tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets} 153 tar -xzf "${DISTDIR}/${tarball}" ${targets}
127 154 eend $? || die "failed to unpack"
128 case "${PV}" in
129 4.4.?)
130 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
131 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
132 ;;
133 esac
134
135 # Be backwards compatible for now
136 if [[ $EAPI != 2 ]]; then
137 qt4-build_src_prepare
138 fi
139} 155}
140 156
141# @ECLASS-VARIABLE: PATCHES 157# @ECLASS-VARIABLE: PATCHES
158# @DEFAULT_UNSET
142# @DESCRIPTION: 159# @DESCRIPTION:
143# In case you have patches to apply, specify them in PATCHES variable. Make sure 160# PATCHES array variable containing all various patches to be applied.
144# to specify the full path. This variable is necessary for src_prepare phase. 161# This variable is expected to be defined in global scope of ebuild.
145# example: 162# Make sure to specify the full path. This variable is utilised in
146# PATCHES="${FILESDIR}"/mypatch.patch 163# src_unpack/src_prepare phase, based on EAPI.
147# ${FILESDIR}"/mypatch2.patch"
148# 164#
165# @CODE
166# PATCHES=( "${FILESDIR}/mypatch.patch"
167# "${FILESDIR}/patches_folder/" )
168# @CODE
149 169
150# @FUNCTION: qt4-build_src_prepare 170# @FUNCTION: qt4-build_src_prepare
151# @DESCRIPTION: 171# @DESCRIPTION:
152# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 172# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
153# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 173# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
154qt4-build_src_prepare() { 174qt4-build_src_prepare() {
155 setqtenv 175 setqtenv
156 cd "${S}" 176 cd "${S}"
157 177
178 if version_is_at_least "4.7"; then
179 # fix libX11 dependency on non X packages
180 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
181 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
182
183 qt_assistant_cleanup
184 fi
185
186 if use aqua; then
187 # provide a proper macx-g++-64
188 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
189
190 sed -e '/^CONFIG/s:app_bundle::' \
191 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
192 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
193 fi
194
158 if [[ ${PN} != qt-core ]]; then 195 if [[ ${PN} != qt-core ]]; then
159 skip_qmake_build_patch 196 skip_qmake_build
160 skip_project_generation_patch 197 skip_project_generation
161 symlink_binaries_to_buildtree 198 symlink_binaries_to_buildtree
162 fi 199 fi
163 200
201 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
202 # qmake bus errors with -O2 but -O3 works
203 replace-flags -O2 -O3
204 fi
205
164 # Bug 178652 206 # Bug 178652
165 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then 207 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
166 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 208 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
167 append-flags -fno-gcse 209 append-flags -fno-gcse
168 fi 210 fi
169 211
212 if use_if_iuse c++0x; then
213 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
214 ewarn "this is an official standard, some of the reverse dependencies"
215 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
216 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
217 ewarn "disabled."
218 append-flags -std=c++0x
219 fi
220
170 # Unsupported old gcc versions - hardened needs this :( 221 # Unsupported old gcc versions - hardened needs this :(
171 if [[ $(gcc-major-version) -lt "4" ]] ; then 222 if [[ $(gcc-major-version) -lt 4 ]]; then
172 ewarn "Appending -fno-stack-protector to CXXFLAGS" 223 ewarn "Appending -fno-stack-protector to CXXFLAGS"
173 append-cxxflags -fno-stack-protector 224 append-cxxflags -fno-stack-protector
174 # Bug 253127 225 # Bug 253127
175 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 226 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
176 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 227 -i mkspecs/common/g++.conf || die
177 fi 228 fi
229
230 # Bug 261632
231 if use ppc64; then
232 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
233 append-flags -mminimal-toc
234 fi
235
236 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
237 sed -e "/^SYSTEM_VARIABLES=/i \
238 CC='$(tc-getCC)'\n\
239 CXX='$(tc-getCXX)'\n\
240 CFLAGS='${CFLAGS}'\n\
241 CXXFLAGS='${CXXFLAGS}'\n\
242 LDFLAGS='${LDFLAGS}'\n" \
243 -i configure \
244 || die "sed SYSTEM_VARIABLES failed"
245
246 # Respect CC, CXX, LINK and *FLAGS in config.tests
247 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
248 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
249 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
250 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
251 || die "sed config.tests failed"
252
253 # Strip predefined CFLAGS from mkspecs (bug 312689)
254 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
178 255
179 # Bug 172219 256 # Bug 172219
257 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
258
259 if [[ ${CHOST} == *-darwin* ]]; then
260 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
261 # crippled (by design) :/
262 sed \
180 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 263 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
181 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 264 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
182 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 265 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
183 -e "s:X11R6/::" \ 266 -e "s:-arch\s\w*::g" \
184 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 267 -i mkspecs/common/mac-g++.conf \
268 || die "sed mkspecs/common/mac-g++.conf failed"
185 269
186 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 270 # Fix configure's -arch settings that appear in qmake/Makefile and also
187 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 271 # fix arch handling (automagically duplicates our -arch arg and breaks
188 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 272 # pch). Additionally disable Xarch support.
189 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 273 sed \
274 -e "s:-arch i386::" \
275 -e "s:-arch ppc::" \
276 -e "s:-arch x86_64::" \
277 -e "s:-arch ppc64::" \
278 -e "s:-arch \$i::" \
279 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
280 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
281 -e "s:-Xarch_x86_64::g" \
282 -e "s:-Xarch_ppc64::g" \
283 -i configure mkspecs/common/mac-g++.conf \
284 || die "sed -arch/-Xarch failed"
285
286 # On Snow Leopard don't fall back to 10.5 deployment target.
287 if [[ ${CHOST} == *-apple-darwin10 ]]; then
288 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
289 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
290 -i configure mkspecs/common/mac-g++.conf \
291 || die "sed deployment target failed"
292 fi
293 fi
294
295 # this one is needed for all systems with a separate -liconv, apart from
296 # Darwin, for which the sources already cater for -liconv
297 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
298 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
299 -i config.tests/unix/iconv/iconv.pro \
300 || die "sed iconv.pro failed"
301 fi
302
303 # we need some patches for Solaris
304 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
305 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
306 # use GCC over SunStudio
307 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
308 # do not flirt with non-Prefix stuff, we're quite possessive
309 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
310 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
190 311
191 base_src_prepare 312 base_src_prepare
192} 313}
193 314
194# @FUNCTION: qt4-build_src_configure 315# @FUNCTION: qt4-build_src_configure
196# Default configure phase 317# Default configure phase
197qt4-build_src_configure() { 318qt4-build_src_configure() {
198 setqtenv 319 setqtenv
199 myconf="$(standard_configure_options) ${myconf}" 320 myconf="$(standard_configure_options) ${myconf}"
200 321
322 # this one is needed for all systems with a separate -liconv, apart from
323 # Darwin, for which the sources already cater for -liconv
324 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
325 myconf+=" -liconv"
326 fi
327
328 if use_if_iuse glib; then
329 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
330 # avoid the -pthread argument
331 myconf+=" ${glibflags//-pthread}"
332 unset glibflags
333 fi
334
335 if use_if_iuse qpa; then
336 ewarn
337 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
338 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
339 ewarn "disable it before reporting any bugs related to this useflag."
340 ewarn
341 myconf+=" -qpa"
342 fi
343
344 if use aqua; then
345 # On (snow) leopard use the new (frameworked) cocoa code.
346 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
347 myconf+=" -cocoa -framework"
348 # We need the source's headers, not the installed ones.
349 myconf+=" -I${S}/include"
350 # Add hint for the framework location.
351 myconf+=" -F${QTLIBDIR}"
352
353 # We are crazy and build cocoa + qt3support :-)
354 if use qt3support; then
355 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
356 -i configure || die
357 fi
358 else
359 myconf+=" -no-framework"
360 fi
361 else
362 # freetype2 include dir is non-standard, thus include it on configure
363 # use -I from configure
364 myconf+=" $(pkg-config --cflags freetype2)"
365 fi
366
201 echo ./configure ${myconf} 367 echo ./configure ${myconf}
202 ./configure ${myconf} || die "./configure failed" 368 ./configure ${myconf} || die "./configure failed"
369 myconf=""
370
371 prepare_directories ${QT4_TARGET_DIRECTORIES}
203} 372}
204 373
205# @FUNCTION: qt4-build_src_compile 374# @FUNCTION: qt4-build_src_compile
375# @DESCRIPTION:
206# @DESCRIPTION: Actual compile phase 376# Actual compile phase
207qt4-build_src_compile() { 377qt4-build_src_compile() {
208 setqtenv 378 setqtenv
209 # Be backwards compatible for now
210 if [[ $EAPI != 2 ]]; then
211 qt4-build_src_configure
212 fi
213 379
214 build_directories "${QT4_TARGET_DIRECTORIES}" 380 build_directories ${QT4_TARGET_DIRECTORIES}
381}
382
383# @FUNCTION: qt4-build_src_test
384# @DESCRIPTION:
385# Runs tests only in target directories.
386qt4-build_src_test() {
387 # QtMultimedia does not have any test suite (bug #332299)
388 [[ ${PN} == "qt-multimedia" ]] && return
389
390 for dir in ${QT4_TARGET_DIRECTORIES}; do
391 emake -j1 check -C ${dir}
392 done
393}
394
395# @FUNCTION: fix_includes
396# @DESCRIPTION:
397# For MacOS X we need to add some symlinks when frameworks are
398# being used, to avoid complications with some more or less stupid packages.
399fix_includes() {
400 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
401 # Some packages tend to include <Qt/...>
402 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
403
404 # Fake normal headers when frameworks are installed... eases life later on
405 local dest f h
406 for frw in "${D}${QTLIBDIR}"/*.framework; do
407 [[ -e "${frw}"/Headers ]] || continue
408 f=$(basename ${frw})
409 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
410 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
411
412 # Link normal headers as well.
413 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
414 h=$(basename ${hdr})
415 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
416 done
417 done
418 fi
215} 419}
216 420
217# @FUNCTION: qt4-build_src_install 421# @FUNCTION: qt4-build_src_install
218# @DESCRIPTION: 422# @DESCRIPTION:
219# Perform the actual installation including some library fixes. 423# Perform the actual installation including some library fixes.
220qt4-build_src_install() { 424qt4-build_src_install() {
425 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
221 setqtenv 426 setqtenv
427
222 install_directories "${QT4_TARGET_DIRECTORIES}" 428 install_directories ${QT4_TARGET_DIRECTORIES}
223 install_qconfigs 429 install_qconfigs
224 fix_library_files 430 fix_library_files
431 fix_includes
432
433 # remove .la files since we are building only shared Qt libraries
434 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
225} 435}
226 436
227# @FUNCTION: setqtenv 437# @FUNCTION: setqtenv
438# @INTERNAL
228setqtenv() { 439setqtenv() {
229 # Set up installation directories 440 # Set up installation directories
230 QTBASEDIR=/usr/$(get_libdir)/qt4
231 QTPREFIXDIR=/usr 441 QTPREFIXDIR=${EPREFIX}/usr
232 QTBINDIR=/usr/bin 442 QTBINDIR=${EPREFIX}/usr/bin
233 QTLIBDIR=/usr/$(get_libdir)/qt4 443 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
234 QMAKE_LIBDIR_QT=${QTLIBDIR}
235 QTPCDIR=/usr/$(get_libdir)/pkgconfig 444 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
236 QTDATADIR=/usr/share/qt4
237 QTDOCDIR=/usr/share/doc/qt-${PV} 445 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
238 QTHEADERDIR=/usr/include/qt4 446 QTHEADERDIR=${EPREFIX}/usr/include/qt4
239 QTPLUGINDIR=${QTLIBDIR}/plugins 447 QTPLUGINDIR=${QTLIBDIR}/plugins
240 QTSYSCONFDIR=/etc/qt4 448 QTIMPORTDIR=${QTLIBDIR}/imports
449 QTDATADIR=${EPREFIX}/usr/share/qt4
241 QTTRANSDIR=${QTDATADIR}/translations 450 QTTRANSDIR=${QTDATADIR}/translations
451 QTSYSCONFDIR=${EPREFIX}/etc/qt4
242 QTEXAMPLESDIR=${QTDATADIR}/examples 452 QTEXAMPLESDIR=${QTDATADIR}/examples
243 QTDEMOSDIR=${QTDATADIR}/demos 453 QTDEMOSDIR=${QTDATADIR}/demos
454 QMAKE_LIBDIR_QT=${QTLIBDIR}
244 QT_INSTALL_PREFIX=/usr/$(get_libdir)/qt4 455 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
456
245 PLATFORM=$(qt_mkspecs_dir) 457 PLATFORM=$(qt_mkspecs_dir)
246 458
247 unset QMAKESPEC 459 unset QMAKESPEC
248} 460}
249 461
250# @FUNCTION: standard_configure_options 462# @FUNCTION: standard_configure_options
463# @INTERNAL
251# @DESCRIPTION: 464# @DESCRIPTION:
252# Sets up some standard configure options, like libdir (if necessary), whether 465# Sets up some standard configure options, like libdir (if necessary), whether
253# debug info is wanted or not. 466# debug info is wanted or not.
254standard_configure_options() { 467standard_configure_options() {
255 local myconf="" 468 local myconf="
469 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
470 -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR} -plugindir ${QTPLUGINDIR}
471 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
472 -datadir ${QTDATADIR} -translationdir ${QTTRANSDIR} -sysconfdir ${QTSYSCONFDIR}
473 -examplesdir ${QTEXAMPLESDIR} -demosdir ${QTDEMOSDIR}
474 -opensource -confirm-license -shared -fast -largefile -stl -verbose
475 -platform $(qt_mkspecs_dir) -nomake examples -nomake demos"
256 476
257 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 477 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
258 478
259 # Disable visibility explicitly if gcc version isn't 4 479 # debug/release
260 if [[ "$(gcc-major-version)" -lt "4" ]]; then
261 myconf="${myconf} -no-reduce-exports"
262 fi
263
264 # precompiled headers doesn't work on hardened, where the flag is masked.
265 if use pch; then 480 if use debug; then
266 myconf="${myconf} -pch" 481 myconf+=" -debug"
267 else 482 else
268 myconf="${myconf} -no-pch" 483 myconf+=" -release"
269 fi 484 fi
270
271 if use debug; then
272 myconf="${myconf} -debug -no-separate-debug-info" 485 myconf+=" -no-separate-debug-info"
273 else 486
274 myconf="${myconf} -release -no-separate-debug-info" 487 # exceptions USE flag
275 fi 488 myconf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
489
490 # disable RPATH on Qt >= 4.8 (bug 380415)
491 version_is_at_least 4.8 && myconf+=" -no-rpath"
492
493 # precompiled headers don't work on hardened, where the flag is masked
494 myconf+=" $(qt_use pch)"
495
496 # -reduce-relocations
497 # This flag seems to introduce major breakage to applications,
498 # mostly to be seen as a core dump with the message "QPixmap: Must
499 # construct a QApplication before a QPaintDevice" on Solaris.
500 # -- Daniel Vergien
501 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
276 502
277 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 503 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
278 # $(tc-arch). Therefore we convert it to supported values. 504 # $(tc-arch). Therefore we convert it to supported values.
279 case "$(tc-arch)" in 505 case "$(tc-arch)" in
280 amd64) myconf="${myconf} -arch x86_64" ;; 506 amd64|x64-*) myconf+=" -arch x86_64" ;;
507 ppc-macos) myconf+=" -arch ppc" ;;
281 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 508 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
509 sparc|sparc-*|sparc64-*) myconf+=" -arch sparc" ;;
510 x86-macos) myconf+=" -arch x86" ;;
282 x86|x86-*) myconf="${myconf} -arch i386" ;; 511 x86|x86-*) myconf+=" -arch i386" ;;
283 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 512 alpha|arm|ia64|mips|s390) myconf+=" -arch $(tc-arch)" ;;
284 hppa|sh) myconf="${myconf} -arch generic" ;; 513 hppa|sh) myconf+=" -arch generic" ;;
285 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 514 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
286 esac 515 esac
287 516
288 myconf="${myconf} -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license -no-rpath
289 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
290 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
291 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
292 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
293 -demosdir ${QTDEMOSDIR} -silent -fast
294 $([[ ${PN} == qt-xmlpatterns ]] || echo -no-exceptions)
295 -reduce-relocations -nomake examples -nomake demos"
296
297 # Make eclass 4.5.{1,2} ready
298 case "${MY_PV}" in
299 4.5.1 | 4.5.2)
300 myconf="${myconf} -opensource"
301 ;;
302 esac
303
304 echo "${myconf}" 517 echo "${myconf}"
305} 518}
519
520# @FUNCTION: prepare_directories
521# @USAGE: < directories >
522# @INTERNAL
523# @DESCRIPTION:
524# Generates Makefiles for the given list of directories.
525prepare_directories() {
526 for x in "$@"; do
527 pushd "${S}"/${x} >/dev/null || die
528 einfo "Running qmake in: ${x}"
529 # avoid running over the maximum argument number, bug #299810
530 {
531 echo "${S}"/mkspecs/common/*.conf
532 find "${S}" -name '*.pr[io]'
533 } | xargs sed -i \
534 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
535 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
536 || die
537 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
538 popd >/dev/null || die
539 done
540}
541
306 542
307# @FUNCTION: build_directories 543# @FUNCTION: build_directories
308# @USAGE: < directories > 544# @USAGE: < directories >
545# @INTERNAL
309# @DESCRIPTION: 546# @DESCRIPTION:
310# Compiles the code in $QT4_TARGET_DIRECTORIES 547# Compiles the code in the given list of directories.
311build_directories() { 548build_directories() {
312 local dirs="$@"
313 for x in ${dirs}; do 549 for x in "$@"; do
314 cd "${S}"/${x} 550 pushd "${S}"/${x} >/dev/null || die
315 sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:/usr/$(get_libdir)/qt4:g" $(find "${S}" -name '*.pr[io]') "${S}"/mkspecs/common/linux.conf || die 551 emake CC="$(tc-getCC)" \
316 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 552 CXX="$(tc-getCXX)" \
317 emake || die "emake failed" 553 LINK="$(tc-getCXX)" || die "emake failed"
554 popd >/dev/null || die
318 done 555 done
319} 556}
320 557
321# @FUNCTION: install_directories 558# @FUNCTION: install_directories
322# @USAGE: < directories > 559# @USAGE: < directories >
560# @INTERNAL
323# @DESCRIPTION: 561# @DESCRIPTION:
324# run emake install in the given directories, which are separated by spaces 562# Runs emake install in the given directories, which are separated by spaces.
325install_directories() { 563install_directories() {
326 local dirs="$@"
327 for x in ${dirs}; do 564 for x in "$@"; do
328 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 565 pushd "${S}"/${x} >/dev/null || die
329 emake INSTALL_ROOT="${D}" install || die "emake install failed" 566 emake INSTALL_ROOT="${D}" install || die "emake install failed"
330 popd >/dev/null || die "Can't popd from ${S}/${x}" 567 popd >/dev/null || die
331 done 568 done
332} 569}
333 570
334# @ECLASS-VARIABLE: QCONFIG_ADD 571# @ECLASS-VARIABLE: QCONFIG_ADD
335# @DESCRIPTION: 572# @DESCRIPTION:
336# List options that need to be added to QT_CONFIG in qconfig.pri 573# List options that need to be added to QT_CONFIG in qconfig.pri
337QCONFIG_ADD="${QCONFIG_ADD:-}" 574: ${QCONFIG_ADD:=}
338 575
339# @ECLASS-VARIABLE: QCONFIG_REMOVE 576# @ECLASS-VARIABLE: QCONFIG_REMOVE
340# @DESCRIPTION: 577# @DESCRIPTION:
341# List options that need to be removed from QT_CONFIG in qconfig.pri 578# List options that need to be removed from QT_CONFIG in qconfig.pri
342QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 579: ${QCONFIG_REMOVE:=}
343 580
344# @ECLASS-VARIABLE: QCONFIG_DEFINE 581# @ECLASS-VARIABLE: QCONFIG_DEFINE
345# @DESCRIPTION: 582# @DESCRIPTION:
346# List variables that should be defined at the top of QtCore/qconfig.h 583# List variables that should be defined at the top of QtCore/qconfig.h
347QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 584: ${QCONFIG_DEFINE:=}
348 585
349# @FUNCTION: install_qconfigs 586# @FUNCTION: install_qconfigs
587# @INTERNAL
588# @DESCRIPTION:
350# @DESCRIPTION: Install gentoo-specific mkspecs configurations 589# Install gentoo-specific mkspecs configurations.
351install_qconfigs() { 590install_qconfigs() {
352 local x 591 local x
353 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 592 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
354 for x in QCONFIG_ADD QCONFIG_REMOVE; do 593 for x in QCONFIG_ADD QCONFIG_REMOVE; do
355 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 594 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
356 done 595 done
357 insinto ${QTDATADIR}/mkspecs/gentoo 596 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
358 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 597 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
359 fi 598 fi
360 599
361 if [[ -n ${QCONFIG_DEFINE} ]]; then 600 if [[ -n ${QCONFIG_DEFINE} ]]; then
362 for x in ${QCONFIG_DEFINE}; do 601 for x in ${QCONFIG_DEFINE}; do
363 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 602 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
364 done 603 done
365 insinto ${QTHEADERDIR}/Gentoo 604 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
366 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 605 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
367 fi 606 fi
368} 607}
369 608
370# @FUNCTION: generate_qconfigs 609# @FUNCTION: generate_qconfigs
371# @DESCRIPTION: Generates gentoo-specific configurations 610# @INTERNAL
611# @DESCRIPTION:
612# Generates gentoo-specific qconfig.{h,pri}.
372generate_qconfigs() { 613generate_qconfigs() {
373 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 614 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then
374 local x qconfig_add qconfig_remove qconfig_new 615 local x qconfig_add qconfig_remove qconfig_new
375 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 616 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
376 [[ -f ${x} ]] || continue 617 [[ -f ${x} ]] || continue
377 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 618 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
378 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 619 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
379 done 620 done
380 621
381 # these error checks do not use die because dying in pkg_post{inst,rm} 622 # these error checks do not use die because dying in pkg_post{inst,rm}
382 # just makes things worse. 623 # just makes things worse.
383 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 624 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
390 631
391 # generate list of QT_CONFIG entries from the existing list 632 # generate list of QT_CONFIG entries from the existing list
392 # including qconfig_add and excluding qconfig_remove 633 # including qconfig_add and excluding qconfig_remove
393 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 634 for x in $(sed -n 's/^QT_CONFIG +=//p' \
394 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 635 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
395 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 636 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
396 done 637 done
397 638
398 # replace the existing QT_CONFIG list with qconfig_new 639 # replace the existing QT_CONFIG list with qconfig_new
399 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 640 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
400 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 641 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
424 fi 665 fi
425 fi 666 fi
426} 667}
427 668
428# @FUNCTION: qt4-build_pkg_postrm 669# @FUNCTION: qt4-build_pkg_postrm
670# @DESCRIPTION:
429# @DESCRIPTION: Generate configurations when the package is completely removed 671# Regenerate configuration when the package is completely removed.
430qt4-build_pkg_postrm() { 672qt4-build_pkg_postrm() {
431 generate_qconfigs 673 generate_qconfigs
432} 674}
433 675
434# @FUNCTION: qt4-build_pkg_postinst 676# @FUNCTION: qt4-build_pkg_postinst
677# @DESCRIPTION:
435# @DESCRIPTION: Generate configuration, plus throws a message about possible 678# Regenerate configuration, plus throw a message about possible
436# breakages and proposed solutions. 679# breakages and proposed solutions.
437qt4-build_pkg_postinst() { 680qt4-build_pkg_postinst() {
438 generate_qconfigs 681 generate_qconfigs
439 echo
440 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
441 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
442 ewarn "should recompile the packages providing these plugins. Also, make sure you"
443 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
444 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
445 ewarn
446 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
447 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
448 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
449 ewarn "configuration."
450 ewarn
451 ewarn "For more information, see http://doc.trolltech.com/${PV%.*}/plugins-howto.html"
452 echo
453} 682}
454 683
455# @FUNCTION: skip_qmake_build_patch 684# @FUNCTION: skip_qmake_build
685# @INTERNAL
456# @DESCRIPTION: 686# @DESCRIPTION:
457# Don't need to build qmake, as it's already installed from qt-core 687# Patches configure to skip qmake compilation, as it's already installed by qt-core.
458skip_qmake_build_patch() { 688skip_qmake_build() {
459 # Don't need to build qmake, as it's already installed from qt-core
460 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 689 sed -i -e "s:if true:if false:g" "${S}"/configure || die
461} 690}
462 691
463# @FUNCTION: skip_project_generation_patch 692# @FUNCTION: skip_project_generation
693# @INTERNAL
464# @DESCRIPTION: 694# @DESCRIPTION:
465# Exit the script early by throwing in an exit before all of the .pro files are scanned 695# Exit the script early by throwing in an exit before all of the .pro files are scanned.
466skip_project_generation_patch() { 696skip_project_generation() {
467 # Exit the script early by throwing in an exit before all of the .pro files are scanned
468 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 697 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
469 -i "${S}"/configure || die "Sed failed"
470} 698}
471 699
472# @FUNCTION: symlink_binaries_to_buildtree 700# @FUNCTION: symlink_binaries_to_buildtree
701# @INTERNAL
473# @DESCRIPTION: 702# @DESCRIPTION:
474# Symlink generated binaries to buildtree so they can be used during compilation 703# Symlinks generated binaries to buildtree, so they can be used during compilation time.
475# time
476symlink_binaries_to_buildtree() { 704symlink_binaries_to_buildtree() {
477 for bin in qmake moc uic rcc; do 705 for bin in qmake moc uic rcc; do
478 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 706 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
479 done 707 done
480} 708}
481 709
482# @FUNCTION: fix_library_files 710# @FUNCTION: fix_library_files
711# @INTERNAL
483# @DESCRIPTION: 712# @DESCRIPTION:
484# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 713# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
485# moves the *.pc-files into the pkgconfig directory 714# moves the *.pc files into the pkgconfig directory.
486fix_library_files() { 715fix_library_files() {
716 local libfile
487 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 717 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
488 if [[ -e ${libfile} ]]; then 718 if [[ -e ${libfile} ]]; then
489 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 719 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
490 fi 720 fi
491 done 721 done
492 722
493 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 723 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
494 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 724 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
495 if [[ -e ${libfile} ]]; then 725 if [[ -e ${libfile} ]]; then
496 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 726 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
497 727
498 # Move .pc files into the pkgconfig directory 728 # Move .pc files into the pkgconfig directory
499 dodir ${QTPCDIR} 729 dodir ${QTPCDIR#${EPREFIX}}
500 mv ${libfile} "${D}"/${QTPCDIR}/ \ 730 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
501 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
502 fi 731 fi
503 done 732 done
504 733
505 # Don't install an empty directory 734 # Don't install an empty directory
506 rmdir "${D}"/${QTLIBDIR}/pkgconfig 735 rmdir "${D}"/${QTLIBDIR}/pkgconfig
507} 736}
508 737
509# @FUNCTION: qt_use 738# @FUNCTION: qt_use
510# @USAGE: < flag > [ feature ] [ enableval ] 739# @USAGE: < flag > [ feature ] [ enableval ]
511# @DESCRIPTION: 740# @DESCRIPTION:
512# This will echo "${enableval}-${feature}" if <flag> is enabled, or 741# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
513# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 742# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
514# will be used for that. If [enableval] is not specified, it omits the 743# will be used for that. If [enableval] is not specified, it omits the
515# assignment-part 744# "-${enableval}" part.
516qt_use() { 745qt_use() {
517 local flag="${1}" 746 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
518 local feature="${1}"
519 local enableval=
520
521 [[ -n ${2} ]] && feature=${2}
522 [[ -n ${3} ]] && enableval="-${3}"
523
524 if use ${flag}; then
525 echo "${enableval}-${feature}"
526 else
527 echo "-no-${feature}"
528 fi
529}
530
531# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK
532# @DESCRIPTION:
533# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use
534# (eutils.eclass), line per line.
535#
536# Example:
537# @CODE
538# pkg_setup() {
539# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
540# ~x11-libs/qt-gui-${PV} qt3support"
541# qt4-build_check_use
542# }
543# @CODE
544
545# Run built_with_use on each flag and print appropriate error messages if any
546# flags are missing
547
548_qt_built_with_use() {
549 local missing opt pkg flag flags
550
551 if [[ ${1} = "--missing" ]]; then
552 missing="${1} ${2}" && shift 2
553 fi
554 if [[ ${1:0:1} = "-" ]]; then
555 opt=${1} && shift
556 fi
557
558 pkg=${1} && shift
559
560 for flag in "${@}"; do
561 flags="${flags} ${flag}"
562 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
563 flags="${flags}*"
564 else
565 [[ ${opt} = "-o" ]] && return 0
566 fi
567 done
568 if [[ "${flags# }" = "${@}" ]]; then
569 return 0
570 fi
571 if [[ ${opt} = "-o" ]]; then
572 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
573 else
574 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
575 fi
576 return 1
577}
578
579# @FUNCTION: qt4-build_check_use
580# @DESCRIPTION:
581# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
582# USE flags listed.
583#
584# If any of the required USE flags are missing, an eerror will be printed for
585# each package with missing USE flags.
586qt4-build_check_use() {
587 local line missing
588 while read line; do
589 [[ -z ${line} ]] && continue
590 if ! _qt_built_with_use ${line}; then
591 missing=true
592 fi
593 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
594 if [[ -n ${missing} ]]; then
595 echo
596 eerror "Flags marked with an * are missing."
597 die "Missing USE flags found"
598 fi
599} 747}
600 748
601# @FUNCTION: qt_mkspecs_dir 749# @FUNCTION: qt_mkspecs_dir
602# @RETURN: the specs-directory w/o path 750# @RETURN: the specs-directory w/o path
603# @DESCRIPTION: 751# @DESCRIPTION:
604# Allows us to define which mkspecs dir we want to use. 752# Allows us to define which mkspecs dir we want to use.
605qt_mkspecs_dir() { 753qt_mkspecs_dir() {
606 # Allows us to define which mkspecs dir we want to use.
607 local spec 754 local spec=
608
609 case ${CHOST} in 755 case ${CHOST} in
610 *-freebsd*|*-dragonfly*) 756 *-freebsd*|*-dragonfly*)
611 spec="freebsd" ;; 757 spec=freebsd ;;
612 *-openbsd*) 758 *-openbsd*)
613 spec="openbsd" ;; 759 spec=openbsd ;;
614 *-netbsd*) 760 *-netbsd*)
615 spec="netbsd" ;; 761 spec=netbsd ;;
616 *-darwin*) 762 *-darwin*)
763 if use aqua; then
764 # mac with carbon/cocoa
765 spec=macx
766 else
767 # darwin/mac with x11
617 spec="darwin" ;; 768 spec=darwin
769 fi
770 ;;
771 *-solaris*)
772 spec=solaris ;;
618 *-linux-*|*-linux) 773 *-linux-*|*-linux)
619 spec="linux" ;; 774 spec=linux ;;
620 *) 775 *)
621 die "Unknown CHOST, no platform choosen." 776 die "Unknown CHOST, no platform chosen"
622 esac 777 esac
623 778
624 CXX=$(tc-getCXX) 779 CXX=$(tc-getCXX)
625 if [[ ${CXX/g++/} != ${CXX} ]]; then 780 if [[ ${CXX} == *g++* ]]; then
626 spec="${spec}-g++" 781 spec+=-g++
627 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 782 elif [[ ${CXX} == *icpc* ]]; then
628 spec="${spec}-icc" 783 spec+=-icc
629 else 784 else
630 die "Unknown compiler ${CXX}." 785 die "Unknown compiler '${CXX}'"
631 fi 786 fi
632 if [[ -n "${LIBDIR/lib}" ]]; then 787
633 spec="${spec}-${LIBDIR/lib}" 788 # Add -64 for 64bit profiles
789 if use x64-freebsd ||
790 use amd64-linux ||
791 use x64-macos ||
792 use x64-solaris ||
793 use sparc64-solaris
794 then
795 spec+=-64
634 fi 796 fi
635 797
636 echo "${spec}" 798 echo "${spec}"
637} 799}
638 800
639case ${EAPI:-0} in 801# @FUNCTION: qt_assistant_cleanup
640 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 802# @INTERNAL
803# @DESCRIPTION:
804# Tries to clean up tools.pro for qt-assistant ebuilds.
805# Meant to be called in src_prepare().
806# Since Qt 4.7.4 this function is a no-op.
807qt_assistant_cleanup() {
808 # apply patching to qt-assistant ebuilds only
809 [[ ${PN} != "qt-assistant" ]] && return
810
811 # no longer needed for 4.7.4 and later
812 version_is_at_least "4.7.4" && return
813
814 # different versions (and branches...) may need different handling,
815 # add a case if you need special handling
816 case "${MY_PV_EXTRA}" in
817 *kde-qt*)
818 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
819 -e "/mac/,/^embedded.*makeqpf$/d" \
820 -i tools/tools.pro || die "patching tools.pro failed"
821 ;;
822 *)
823 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
824 -e "/mac/,/^embedded.*makeqpf$/d" \
825 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
826 -i tools/tools.pro || die "patching tools.pro failed"
827 ;;
828 esac
829}
830
831# @FUNCTION: qt_nolibx11
832# @INTERNAL
833# @DESCRIPTION:
834# Ignore X11 tests for packages that don't need X libraries installed.
835qt_nolibx11() {
836 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
837 die "x11 check sed failed"
838}
839
641 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 840EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
642esac

Legend:
Removed from v.1.42  
changed lines
  Added in v.1.120

  ViewVC Help
Powered by ViewVC 1.1.20